CUTLASS: cutlass::integer_subbyte< Bits, Signed > Struct Template Reference

| CUTLASS CUDA Templates for Linear Algebra Subroutines and Solvers

- Main Page
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Public Attributes | Static Public Attributes | List of all members
cutlass::integer_subbyte< Bits, Signed > Struct Template Reference

4-bit signed integer type

`#include <integer_subbyte.h>`

## Public Types
using | T = typename std::conditional< kSigned, int, unsigned >::type
| External type. More...
using | Storage = uint8_t
| Storage type. More...

## Public Member Functions
CUTLASS_HOST_DEVICE | integer_subbyte ()
| No operation. More...
CUTLASS_HOST_DEVICE | integer_subbyte (int value)
| Conversion from integer type. More...
CUTLASS_HOST_DEVICE | integer_subbyte (unsigned value)
CUTLASS_HOST_DEVICE | integer_subbyte (double value)
| Conversion from double. More...
CUTLASS_HOST_DEVICE | operator T () const
CUTLASS_HOST_DEVICE bool | operator== (integer_subbyte const &rhs) const
| Equality. More...
CUTLASS_HOST_DEVICE bool | operator!= (integer_subbyte const &rhs) const
| Inequality. More...
CUTLASS_HOST_DEVICE bool | operator<= (integer_subbyte const &rhs) const
| Less than or equal. More...
CUTLASS_HOST_DEVICE bool | operator< (integer_subbyte const &rhs) const
| Less than. More...
CUTLASS_HOST_DEVICE bool | operator>= (integer_subbyte const &rhs) const
| Greater than or equal. More...
CUTLASS_HOST_DEVICE bool | operator> (integer_subbyte const &rhs) const
| Greater than. More...

## Public Attributes
Storage | storage

## Static Public Attributes
static int const | kBits = Bits
| Number of bits. More...
static bool const | kSigned = Signed
| Whether type is signed. More...
static Storage const | kMask = Storage((1 << kBits) - 1)
| Bitmask used to truncate from larger integers. More...

## Member Typedef Documentation

template<int Bits, bool Signed = true>

using cutlass::integer_subbyte< Bits, Signed >::Storage = uint8_t

template<int Bits, bool Signed = true>

using cutlass::integer_subbyte< Bits, Signed >::T = typename std::conditional<kSigned, int, unsigned>::type

## Constructor & Destructor Documentation

template<int Bits, bool Signed = true>

CUTLASS_HOST_DEVICE cutlass::integer_subbyte< Bits, Signed >::integer_subbyte | ( |  | ) |
| inline

template<int Bits, bool Signed = true>

CUTLASS_HOST_DEVICE cutlass::integer_subbyte< Bits, Signed >::integer_subbyte | ( | int | value | ) |
| inline

template<int Bits, bool Signed = true>

CUTLASS_HOST_DEVICE cutlass::integer_subbyte< Bits, Signed >::integer_subbyte | ( | unsigned | value | ) |
| inline

template<int Bits, bool Signed = true>

CUTLASS_HOST_DEVICE cutlass::integer_subbyte< Bits, Signed >::integer_subbyte | ( | double | value | ) |
| inline

## Member Function Documentation

template<int Bits, bool Signed = true>

CUTLASS_HOST_DEVICE cutlass::integer_subbyte< Bits, Signed >::operator T | ( |  | ) | const
| inline

template<int Bits, bool Signed = true>

CUTLASS_HOST_DEVICE bool cutlass::integer_subbyte< Bits, Signed >::operator!= | ( | integer_subbyte< Bits, Signed > const & | rhs | ) | const
| inline

template<int Bits, bool Signed = true>

CUTLASS_HOST_DEVICE bool cutlass::integer_subbyte< Bits, Signed >::operator< | ( | integer_subbyte< Bits, Signed > const & | rhs | ) | const
| inline

template<int Bits, bool Signed = true>

CUTLASS_HOST_DEVICE bool cutlass::integer_subbyte< Bits, Signed >::operator<= | ( | integer_subbyte< Bits, Signed > const & | rhs | ) | const
| inline

template<int Bits, bool Signed = true>

CUTLASS_HOST_DEVICE bool cutlass::integer_subbyte< Bits, Signed >::operator== | ( | integer_subbyte< Bits, Signed > const & | rhs | ) | const
| inline

template<int Bits, bool Signed = true>

CUTLASS_HOST_DEVICE bool cutlass::integer_subbyte< Bits, Signed >::operator> | ( | integer_subbyte< Bits, Signed > const & | rhs | ) | const
| inline

template<int Bits, bool Signed = true>

CUTLASS_HOST_DEVICE bool cutlass::integer_subbyte< Bits, Signed >::operator>= | ( | integer_subbyte< Bits, Signed > const & | rhs | ) | const
| inline

## Member Data Documentation

template<int Bits, bool Signed = true>

int const cutlass::integer_subbyte< Bits, Signed >::kBits = Bits
| static

template<int Bits, bool Signed = true>

Storage const cutlass::integer_subbyte< Bits, Signed >::kMask = Storage((1 << kBits) - 1)
| static

template<int Bits, bool Signed = true>

bool const cutlass::integer_subbyte< Bits, Signed >::kSigned = Signed
| static

template<int Bits, bool Signed = true>

Storage cutlass::integer_subbyte< Bits, Signed >::storage

The documentation for this struct was generated from the following file:

- integer_subbyte.h